//---------------------------------------------------------------------------
#include <cstring>

#include "resource.h"
#include "utils.h"

//---------------------------------------------------------------------------
#ifndef NULL
#define NULL 0
#endif

//Vector TrackedObject::tags;
vector<TrackedObject *> TrackedObject::tags;
//VisionException *Vision::error = NULL;

TrackedObject::TrackedObject() {
	this->tag = TrackedObject::addTag(this);
	//LOG("New Tracked Object, tag = %d\n", this->tag);
	this->deleteLevel = 0;
}

TrackedObject::~TrackedObject() {
	//LOG("Deleting Tracked Object, tag = %d\n", this->tag);
	removeTag(this->tag);
}

void TrackedObject::flushAll() {
	LOG("TrackedObject::flushAll()\n");
	for(unsigned int i=0;i<tags.size();i++) {
		//TrackedObject *vo = (TrackedObject *)tags.getData()[i];
		TrackedObject *vo = tags.at(i);
		if(vo != NULL) {
			delete vo;
			//tags.getData()[i] = NULL;
			tags[i] = NULL;
		}
	}
}

void TrackedObject::flush(int deleteLevel) {
	LOG("TrackedObject::flush(%d)\n", deleteLevel);
	for(unsigned int i=0;i<tags.size();i++) {
		//TrackedObject *vo = (TrackedObject *)tags.getData()[i];
		TrackedObject *vo = tags.at(i);
		if(vo != NULL && vo->deleteLevel >= deleteLevel) {
			delete vo;
			//tags.getData()[i] = NULL;
			tags[i] = NULL;
		}
	}
}

void TrackedObject::cleanup() {
	LOG("TrackedObject::cleanup()\n");
	flushAll();

	/*if(error != NULL)
	delete error;*/

	/*#ifdef _DEBUG
	dumpAllocs();
	#endif*/
}

int TrackedObject::addTag(TrackedObject *ptr) {
	int tag = tags.size() + 1;
	//tags.add(ptr);
	tags.push_back(ptr);
	return tag;
}

TrackedObject *TrackedObject::ptrFromTag(int tag) {
	TrackedObject *ptr = NULL;
	if( tag <= 0 || ((unsigned int)tag) > tags.size() ) {
		// error
		ptr = NULL;
	}
	else {
		//ptr = (TrackedObject *)tags.getData()[tag - 1];
		ptr = tags.at(tag-1);
	}
	return ptr;
}

void TrackedObject::removeTag(int tag) {
	//tags.getData()[tag - 1] = NULL;
	tags[tag-1] = NULL;
}

int TrackedObject::getNumTags() {
	return tags.size();
}

TrackedObject *TrackedObject::getTag(int index) {
	//return (TrackedObject *)tags.elementAt(index);
	return tags.at(index);
}

/*VisionException *Vision::getError() {
return error;
}

void Vision::setError(VisionException *ve) {
if(error != NULL)
delete error;
throw ve;
error = ve;
}*/

bool TrackedObject::isClass(const char *classname) const {
	return ( strcmp( this->getClass(), classname ) == 0 );
}

