//---------------------------------------------------------------------------
#ifndef ResourceH
#define ResourceH

/** A general class that other classes can subclass, to allow things like
*   easier memory management.
*/

#include <vector>
using std::vector;

class TrackedObject {
	static vector<TrackedObject *> tags;
	int tag;
	int deleteLevel;

public:
	TrackedObject();
	virtual ~TrackedObject();

	static void initialise();
	static void flushAll();
	static void flush(int deleteLevel);
	static void cleanup();
	static int addTag(TrackedObject *ptr);
	static void removeTag(int tag);
	static int getNumTags();
	static TrackedObject *getTag(int index);
	static TrackedObject *ptrFromTag(int tag);
	virtual const char *getClass() const=0;
	bool isClass(const char *classname) const;
};

//---------------------------------------------------------------------------
#endif

