//---------------------------------------------------------------------------
#ifndef screenH
#define screenH

/** Class for managing the display. There shouldn't be anything specific to a
*   particlar game in this class.
*/

struct SDL_Surface;

class Screen {
	SDL_Surface *surface;

public:
	Screen();
	~Screen();

	static bool canOpenFullscreen(int width, int height);
	bool open(int screen_width, int screen_height, bool fullscreen);
	void setTitle(const char *title);
	void clear();
	const SDL_Surface *getSurface() const {
		return this->surface;
	}
	SDL_Surface *getSurface() {
		return this->surface;
	}
	int getWidth() const {
		return this->surface->w;
	}
	int getHeight() const {
		return this->surface->h;
	}
};
//---------------------------------------------------------------------------
#endif
