//---------------------------------------------------------------------------
#ifndef soundH
#define soundH

/** Handles sound samples and music.
*/

#include <string>
using std::string;

#include "resource.h"

/*struct FSOUND_SAMPLE;
struct FSOUND_STREAM;
struct FMUSIC_MODULE;*/
#ifdef __linux
#include <fmodex/fmod.hpp>
#else
#include <fmod.hpp>
#endif

bool initSound();
void updateSound();
void freeSound();

class Sample : public TrackedObject {
	//struct FSOUND_SAMPLE *fsound_sample;
	FMOD::Sound *sound;

	string text;
public:
	//Sample(FSOUND_SAMPLE *fsound_sample) : fsound_sample(fsound_sample) {
	Sample(FMOD::Sound *sound) : sound(sound) {
	}
	virtual ~Sample();
	virtual const char *getClass() const { return "CLASS_SAMPLE"; }
	void play(int ch);
	void setText(const char *text) {
		this->text = text;
	}
};

Sample *loadSample(const char *filename, bool iff = false);
Sample *loadSamplesChained(const char *filename1,const char *filename2,const char *filename3);
Sample *loadMusic(const char *filename);

const int SOUND_CHANNEL_SAMPLES = 0;
const int SOUND_CHANNEL_MUSIC   = 1;
const int SOUND_CHANNEL_FX      = 2;

inline void playSample(Sample *sample, int channel = SOUND_CHANNEL_SAMPLES) {
	sample->play(channel);
}

bool isPlaying(int ch);

/*void playStream(FSOUND_STREAM *stream);
void playModule(FMUSIC_MODULE *mod);
void stopModule(FMUSIC_MODULE *mod);*/
bool errorSound();

//---------------------------------------------------------------------------
#endif
